'==============================================================================
' HENON - Fraktal
' HENON.BAS
' Erstellt Maerz 2006
' Letzte Ueberarbeitung 18.12.13
'=========================================================================
  
#include "Inc\TUI.bas"

Dim As Single Alpha, x0, y0, a, b, x, y, dr, x_alt, y_alt
Dim As Integer Farbe, n
Dim As String*1 jn

'Vorbelegte Werte:
Alpha = 76.1135
x0 = 0.1
y0 = 0.1
Farbe = 13

Do
	
	Screen 0
	Color 7, 1
	Cls
	
	Zentriert(1, "Programm HENON")
	Print
	Print "vgl. H. Lauwerier: Fraktale, 1989, Kapitel 7"
	Print
	Print "Bildung der Punktreihe"
	Print "x(n) = a*x(n-1) - b*(y(n-1) - x(n-1)^2)"
	Print "y(n) = b*x(n-1) + a*(y(n-1) - x(n-1)^2)"
	Print
	Print "Die Punktreihe beschreibt also eine gestoerte Rotation"
	Print "mit a = COS(alpha), b = SIN(alpha), alpha = Drehwinkel,"
	Print "Stoerglied = -x(n-1)^2."
	
	Rahmen ("Dateneingabe", "", 17, 15, 22, 65)
	Locate 19, 17: Print "Drehwinkel alpha ...: ";
	Alpha = Val(Edit(Str(Alpha), 10))
	Locate   , 17: Print "Farbe ..............: ";
	Farbe = Val(Edit(Str(Farbe), 10))
	Locate 25, 1
	
	Screenres 640, 480
	Windowtitle "Henon-Fraktal"
	Width 80, 30
	Cls
	Window (-1.2, -0.9) - (1.2, 0.9)
	a = Cos(pi*(Alpha/180))
	b = Sin(pi*(Alpha/180))
	x = x0
	y = y0
	For n = 1 To 1E6
	  If n Mod 1000 = 0 Then
	    'Naechste Bahn
	    dr = 0.01
	    If x < 0 Then x = x - dr Else x = x + dr
	    If y < 0 Then y = y - dr Else y = y + dr
	  End If
	  x_alt = x
	  y_alt = y
	  x = a*x_alt - b*(y_alt - x_alt^2)
	  y = b*x_alt + a*(y_alt - x_alt^2)
	  Pset (x, y), Farbe
	Next n
	Locate 30,34
	Input "Noch einmal j/n: ", jn
	
Loop Until Ucase(jn) = "N"
